#ifndef __FILE_H__
#define __FILE_H__

#include "ablib/TextFile.h"
//#include "ablib/vector.h"
#include <vector>

/**
t@C̊֐񋟁B
KɐFXl߂ĂB
*/

class File
{
public:
	File(void);
	~File(void);
	int OpenFile(const TCHAR *fname,const TCHAR *mode);
	TCHAR *ReadFileLine(int fp);
	int Write(const TCHAR *text,int fp);
	int CloseFile(int fp);
	int TextReadOpen(const TCHAR *fname,int cs);
	TCHAR *TextReadLine();
	int TextReadClose();
	TCHAR *FindFirstFile(const TCHAR *pattern);
	TCHAR *FindNext();
	int FindClose();
	static int CompareTimeStamp(const TCHAR *fname1,const TCHAR *fname2);
	static TCHAR *OpenFileDialog(HWND hwnd,const TCHAR *title,TCHAR *filter,const TCHAR *defdir);
	static TCHAR *OpenDirDialog(HWND hwnd,const TCHAR *title,const TCHAR *defdir);
	static int CALLBACK OpenDirCallBack(HWND hwnd,UINT uMsg,LPARAM lParam,LPARAM data);
	static int DiffFile(const TCHAR *filaname1,const TCHAR *filename2);
	static int CheckSameFile(const TCHAR *filename1,const TCHAR *filename2);
	static int SortFile(const TCHAR *fname);
	static const TCHAR *TransRegularPath(const TCHAR *fn);
	static DWORD GetFilesize(const TCHAR *fname);
	static bool ExistsFile(const TCHAR *filename);
	static const TCHAR *Which(const TCHAR *cmd);
	static int CreateDir(const TCHAR *dir);
	static int DeleteFiles(const TCHAR *file);

private:
	std::vector<FILE *> m_fp;
	HANDLE m_findfile;
	ablib::TextFile m_textfile;
	static int compare(const void *arg1,const void *arg2);
	static int comparei(const void *arg1,const void *arg2);

	NOCOPY(File);
};
#endif //__FILE_H__